{#eclipse_base title='Git ECA Validation' _unisolated}
{#precontent}
{#include eclipse_breadcrumb}{/}
{|<style>
  .panel.list-group>div {
    background-color: white;
    border-left: 1px solid #ddd;
    border-right: 1px solid #ddd;
  }

  .panel.list-group .list-group-item .badge {
    background-color: #ffd8cc;
    color: #c74922;
    border-color: #c74922;
  }

  @media (min-width: 992px) {
    .main-sidebar-default-margin {
      margin-top: 0px;
    }
  }

  .icon-toggle.glyphicon {
    top: 3px;
  }

  a.underline {
    text-decoration: underline;
  }
</style>|}
{/}
{#content_prewrap}
<div class="container" id="main-page-content">
  <div id="main-content-row" class="row">
{/}

{#content}
    <section id="main-content" class="col-md-18 col-sm-16 margin-bottom-20">
      <div id="toast-target">
      </div>
      <h1>Git ECA Validation Status</h1>
      <div class="row">
        <div class="col-md-24 margin-bottom-20">
          {#if !statuses.isEmpty && ((statuses.0.estimatedLoc ne null && statuses.0.estimatedLoc gt 1000) || statuses.0.provider == ProviderType:GITLAB)}
          <div class="alert alert-info">
            <p>
              <strong>Eclipse Intellectual Property Management:</strong>
            </p>
            <p>
              Some contributions of code to be maintained by Eclipse Projects
              must be reviewed by the IP Team; in particular if they contain
              third party content and/or are over 1,000 Lines of Code. Further
              information can be read via the <a href="https://www.eclipse.org/projects/handbook/#ip-project-code">
                Eclipse Handbook</a>.
            </p>
          </div>
          {/if}
          <h2 class="h4 margin-top-0">About this project</h2>
          <ul>
            <li><strong>Eclipse Foundation Project:</strong>
              {#if project}
              YES
              {#else}
              NO
              {/if}
            </li>
            <li><strong>Eclipse Foundation Specification Project:</strong>
              {#if project ne null && project.getSpecWorkingGroup}
              YES
              {#else}
              NO
              {/if}
            </li>
            {#if orgName ne null && repoName ne null && pullRequestNumber ne null && statuses.0.provider == ProviderType:GITHUB}
            <li>
              <strong>Pull request:</strong> <a class="underline" href="https://github.com/{orgName}/{repoName}/pull/{pullRequestNumber}" target="_blank" >#{pullRequestNumber}</a>
            </li>
            {/if}
          </ul>
          <a href="{repoUrl}" target="_blank" rel="noopener" class="btn btn-primary margin-top-10">Project repository</a>
        </div>
      </div>
      {#let validEmails=statuses.getUniquePassedMails}
      {#if validEmails.size > 0 }
      <div class="panel panel-success">
        <div class="panel-heading"><i class="fa fa-check" aria-hidden="true"></i>
          Author(s) covered by necessary legal agreements
        </div>
        <div class="panel-body background-white">
          <ul class="list-group-item-text">
            {#for email in validEmails}
            <li>{email.obfuscateEmail}</li>
            {/for}
          </ul>
        </div>
      </div>
      {/if}
      {/let}
      {#if statuses.getErrorCount > 0}
      <div class="row">
        <div class="col-md-24 margin-bottom-20">
          <div class="panel panel-danger">
            <div class="panel-heading"><i class="fa fa-times" aria-hidden="true"></i>
              Author(s) not covered by necessary legal agreements
            </div>
            <div class="panel-body background-white">
              <ul class="list-group-item-text">
                {#for error in statuses.getValidationErrors}
                <li>{error.getMessageForError.raw}</li>
                {/for}
              </ul>
            </div>
          </div>
        </div>
      </div>
      
      <a id="more-details" href="#accordion" class="big" data-toggle="collapse">More details
        <i class="margin-left-10 icon-toggle glyphicon glyphicon-plus" aria-hidden="true"></i>
      </a>
      <div id="accordion" class="collapse">
        <div class="panel list-group">
          {#for status in statuses.orEmpty}
          <a href="#{status.commitHash}" data-parent="#accordion" data-toggle="collapse" class="list-group-item">
            {#if status.errors.size > 0}
            <span class="badge">{status.errors.size}</span>
            {/if}
            <p>SHA: <strong>{status.commitHash}</strong></p>
          </a>

          <div class="padding-30 collapse" id="{status.commitHash}">
            <div>Last validated: <em>{status.lastModified.format('d MMM uuuu')}</em></div>
            <div>Errors: <em>{status.errors.size}</em></div>
            <ul class="list-group-item-text">
              {#for error in status.errors.orEmpty}
              <li>{error.getMessageForError.raw}</li>
              {/for}
            </ul>
          </div>
          {/for}
        </div>
      </div>
      <div class="row">
        <div class="col-md-24 margin-top-20 margin-bottom-20">
          <div class="panel info-panel">
            <h3 class="panel-heading margin-top-0"><i class="fa fa-info margin-right-15" aria-hidden="true"></i>Common troubleshooting tips</h3>
            <div class="panel-body">
              <p>
                A common error experienced by users is that the email associated with commits do not align with the email set in the Eclipse Foundation account. If you have an Eclipse Foundation account and a signed ECA-equivalent document, there are ways to validate the users and email addresses associated with a commit.
              </p>
              <p>
                Below are 3 sample commands that will display the committer and author emails for a given commit or range. The first command shows the latest commit, while the second command will show results for a given commit, replacing `&lt;SHA&gt;` with the commit SHA. The last example will render a range of sequential commits. As is, it will show the last 5 commits starting from HEAD for the current branch. Both sides of the range can be replaced with commit SHAs to represent a different range. 
              </p>
              <code>
                <span>git show -s --format='Commit: %h, Committer: %ce, Author: %ae</span>
                <br>
                <span>git show -s --format='Commit: %h, Committer: %ce, Author: %ae' &lt;SHA&gt;</span>
                <br>
                <span>git show -s --format='Commit: %h, Committer: %ce, Author: %ae' HEAD...HEAD~5</span>
              </code>
            </div>
          </div>
        </div>
      </div>
      {/if}
      {#if statuses.0.provider == ProviderType:GITHUB && pullRequestNumber != null && repoName != null && orgName != null}
      <div>
        <form id="git-eca-hook-revalidation" data-request-number="{pullRequestNumber}" data-request-repo="{repoName}" data-request-org="{orgName}" data-request-installation="{installationId}">
          <div class="captcha">
            <div class="h-captcha" data-sitekey="{config:['eclipse.hcaptcha.site-key']}"></div>
          </div>
          <button class="btn-success margin-top-10 btn form-submit" type="submit">Revalidate</button>
        </form>
      </div>
      {/if}
    </section>

    <aside id="main-sidebar-secondy" role="complementary" class="col-md-6 col-sm-8 margin-bottom-60" aria-label="eclipse-contributor-agreement">
      <div class="region region-sidebar-second solstice-region-element-count-2">
        <section id="block-site-login-eclipse-eca-sle-eca-lookup-tool"
          class="margin-bottom-30 clearfix">
          <h2>ECA Validation Tool</h2>
          <form id="eclipse-eca-lookup-form" accept-charset="UTF-8">
            <div class="form-item form-item-input form-type-textfield form-group">
              {#if currentUser and currentUser.isCommitter}
              <input placeholder="Enter email address or username" class="form-control form-text" type="text" id="query-input"
                name="query-input" value="" size="21" maxlength="128" autofill-prediction="UNKNOWN_TYPE">
              <div class="help-block">Enter email address or username of an Eclipse account.</div>
              {#else}
              <input placeholder="Enter username" class="form-control form-text" type="text" id="query-input"
                name="query-input" value="" size="21" maxlength="128" autofill-prediction="UNKNOWN_TYPE">
              <div class="help-block">Enter username of an Eclipse account.</div>
              {/if}
            </div>
            <button class="btn-success btn form-submit" type="submit" id="edit-submit">Verify ECA</button>
          </form>
          {#if currentUser == null}
          <hr />
          <p>If you are a committer or project lead and wish to query for users by their email address, please login.</p>
          <a class="btn btn-primary" href="/git/login?redirect={redirectUri}">Login</a>
          {/if}
        </section>
        <section id="block-eclipse-api-github-eclipse-api-github-links" class="main-sidebar-default-margin">
            <ul id="leftnav" class="ul-left-nav fa-ul hidden-print" role="tablist">
              <li class="separator"><a class="separator" href="https://www.eclipse.org/legal/eca/"> ECA </a></li>
              <li class="main-sidebar-item main-sidebar-item-indented">
                <i class="fa fa-caret-right fa-fw" aria-hidden="true"></i>
                <a href="https://accounts.eclipse.org/user/eca" target="_self"> Sign</a>
              </li>
              <li class="separator"><a class="separator" href="https://www.eclipse.org/legal/licenses/"> Licenses
                </a></li>
              <li class="main-sidebar-item main-sidebar-item-indented"><i class="fa fa-caret-right fa-fw" aria-hidden="true"></i> <a href="https://www.eclipse.org/legal/licenses/#approved"
                  target="_self"> Approved 3rd Party </a></li>
              <li class="main-sidebar-item main-sidebar-item-indented"><i class="fa fa-caret-right fa-fw" aria-hidden="true"></i> <a
                  href="https://www.eclipse.org/legal/licenses/#nonapproved" target="_self"> Non Approved </a></li>
              <li class="main-sidebar-item main-sidebar-item-indented"><i class="fa fa-caret-right fa-fw" aria-hidden="true"></i> <a href="https://www.eclipse.org/legal/non-code-licenses/"
                  target="_self"> Docs &amp; examples </a></li>
            </ul>
          </aside>
        </div>
      </section>
    </div>
  </aside>
{/}
{#content_postwrap}
</div>
</div>
{/}

{#postcontent}
<script src="https://hcaptcha.com/1/api.js?hl=en" async="async" defer="defer"></script>
{|
<script>
  document.addEventListener("DOMContentLoaded", function () {
    function toggleIcon(e) {
      $(e.target)
        .prev()
        .find('.icon-toggle')
        .toggleClass('glyphicon-plus glyphicon-minus');
    }
    function escapeHTML(s) {
      return s.replace(/&/g, '&amp;')
        .replace(/"/g, '&quot;')
        .replace(/</g, '&lt;')
        .replace(/>/g, '&gt;');
    }
    function toast(message, type) {
      const $toastTarget = $('#toast-target');
      // create and append the toast notification into the top of the screen
      const $newToast = $(`<div class="margin-top-20 fade in alert alert-${type}">${message}<button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button></div>`);
      $toastTarget.append($newToast);
      // auto dismiss after 10s
      setTimeout(function () {
        $newToast.fadeOut("slow");
      }, 10000);
    }
    // set up accordion
    $('#accordion').on('hidden.bs.collapse', toggleIcon);
    $('#accordion').on('shown.bs.collapse', toggleIcon);
    
    // bind to ECA status lookup submit if present
    var lookupForm = document.getElementById("eclipse-eca-lookup-form");
    if (lookupForm !== null) {
        lookupForm.addEventListener("submit", function (e) {
          // don't submit the form as we will handle it w/ ajax
          e.preventDefault();
          // grab the constants from the form and perform a check
          const inputVal = $(e.target).find('#query-input').val();
          const $submitButton = $(e.target).find('button');
          // disable the button so that requests won't be spammed
          $submitButton.attr("disabled", "disabled");
          // use ajax to check the ECA status of the user
          fetch('/git/eca/lookup?' + new URLSearchParams({
              q: inputVal,
            }).toString()).then(d => {
              if (d.status === 200) {
                toast(`There is a valid ECA on file for <em>${escapeHTML(inputVal)}</em>`, 'success');
              } else if (d.status === 400) {
                // we pull out the message from the error to give user some context 
                d.json().then(error => {
                    toast(`<p>Could not lookup  <em>${escapeHTML(inputVal)}</em></p><p>Reason: ${error.message}</p>`, 'warning');
                });
              } else if (d.status === 404) {
                toast(`No Eclipse Foundation account found for <em>${escapeHTML(inputVal)}</em>`, 'warning');
              } else {
                toast(`Error encountered while checking for an ECA on file for <em>${escapeHTML(inputVal)}</em>`, 'danger');
              }
              $submitButton.removeAttr("disabled");
          });
        });
    }
    
    // Revalidation button binding
    const revalidationForm = document.getElementById("git-eca-hook-revalidation");
    if (revalidationForm !== null) {
      revalidationForm.addEventListener("submit", function (e) {
        // don't submit the form as we will handle it w/ ajax
        e.preventDefault();
        // grab the constants from the form and perform a check
        const $form = $(e.target);
        const $submitButton = $form.find('button');
        // disable the button so that requests won't be spammed
        $submitButton.attr("disabled", "disabled");
        // set up params to set up for revalidation
        let params = $.param({
            repo_name: $form.data('request-repo'),
            org: $form.data('request-org'),
            pull_request_number: $form.data('request-number'),
            installation_id: $form.data('request-installation')
        });
        // use ajax to revalidate the commit with GH
        $.ajax({
          url: `/git/webhooks/github/revalidate?${params}`,
          data: $form.serialize(),
          type: 'POST',
          success: function (data) {
            toast(`Revalidation complete! Forwarding to pull request.`, 'success');
            setTimeout(() => {
              window.location.replace(data.location);
            }, '2500');
          },
          error: function (xhr) {
            const json = JSON.parse(xhr.responseText);
            console.log('Error encountered while revalidating: ' + json.message);
            toast(json.message, 'danger');
          },
          complete: function () {
            $submitButton.removeAttr("disabled");
          }
        });
      });
    }
  });

</script>|}
{/}
{/eclipse_base}